#include "testconfig.h"
#define TEST_FUNC_FF_F __MATH_PRECNAME(wrap_add)
static REAL TEST_FUNC_FF_F(REAL x, REAL y)
{
	return x + y;
}
#include "testdriver.h"


static test_ff_f_data const fadd_data[] = {
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L),  HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(-3.0, 0xc000, 0xc0000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), ZERO_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), ZERO_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, INF_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, INF_M, 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L),  HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_P, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_M, HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), HEXCONSTE(2.0, 0x4000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_M, HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), HEXCONSTE(-2.0, 0xc000, 0x80000000L, 0x00000000L), 0 },
	{ __LINE__, ZERO_P, ZERO_P, ZERO_P, 0 },
	{ __LINE__, ZERO_P, ZERO_M, ZERO_P, 0 },
	{ __LINE__, ZERO_M, ZERO_P, ZERO_P, 0 },
	{ __LINE__, ZERO_M, ZERO_M, ZERO_M, FLAG_FAIL_ARANYM2 },
	{ __LINE__, ZERO_P, INF_P, INF_P, 0 },
	{ __LINE__, ZERO_P, INF_M, INF_M, 0 },
	{ __LINE__, ZERO_M, INF_P, INF_P, 0 },
	{ __LINE__, ZERO_M, INF_M, INF_M, 0 },
	{ __LINE__, INF_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_P, 0 },
	{ __LINE__, INF_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), INF_M, 0 },
	{ __LINE__, INF_P, ZERO_P, INF_P, 0 },
	{ __LINE__, INF_P, ZERO_M, INF_P, 0 },
	{ __LINE__, INF_M, ZERO_P, INF_M, 0 },
	{ __LINE__, INF_M, ZERO_M, INF_M, 0 },
	{ __LINE__, INF_P, INF_P, INF_P, 0 },
	{ __LINE__, INF_P, INF_M, QNAN_P, 0 },
	{ __LINE__, INF_M, INF_P, QNAN_P, 0 },
	{ __LINE__, INF_M, INF_M, INF_M, 0 },
	
	{ __LINE__, ZERO_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, ZERO_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, INF_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, INF_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, ZERO_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, INF_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, INF_P, QNAN_M, 0 },
	{ __LINE__, QNAN_P, INF_M, QNAN_M, 0 },
	{ __LINE__, QNAN_M, INF_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, QNAN_P, QNAN_P, 0 },
	{ __LINE__, QNAN_M, QNAN_P, QNAN_M, 0 },
	{ __LINE__, QNAN_P, QNAN_M, QNAN_M, 0 },
	{ __LINE__, QNAN_M, QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, QNAN_P, 0 },
	{ __LINE__, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_M, QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(1.0, 0x3fff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_P, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },
	{ __LINE__, QNAN_M, HEXCONSTE(-1.0, 0xbfff, 0x80000000L, 0x00000000L), QNAN_P, 0 },

	{ __LINE__, HEXCONST_PI, HEXCONSTE(3.0, 0x4000, 0xc0000000L, 0x00000000L), HEXCONSTE(6.141592653589793238462643383279502884, 0x4001, 0xc487ed51L, 0x10b4611aL), 0 },
	{ __LINE__, HEXCONSTE("0x1p16382", 0x7ffd, 0x80000000L, 0x0L), HEXCONSTE("0x1p16382", 0x7ffd, 0x80000000L, 0x0L), HEXCONSTE("0x1p16383", 0x7ffe, 0x80000000L, 0x0L), 0 },
	{ __LINE__, HEXCONSTE("0x1p16383", 0x7ffe, 0x80000000L, 0x0L), HEXCONSTE("0x1p16383", 0x7ffe, 0x80000000L, 0x0L), INF_P, 0 },
};


int main(int argc, char **argv)
{
	int status;
	
	status = 0;
	
	test_init(argc, argv);
	
	status |= test_table_ff_f(fadd_data, ARRAY_SIZE(fadd_data), __FILE__);
	
	return status ? EXIT_FAILURE : EXIT_SUCCESS;
}
